/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { PolarLineSeriesBase } from "./PolarLineSeriesBase";
import { UnknownValuePlotting_$type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { runOn, enumGetBox, markType, markDep } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { PolarLineSeriesBaseView } from "./PolarLineSeriesBaseView";
import { Defaults } from "./Defaults";
/**
 * @hidden
 */
export let PolarLineSeries = /*@__PURE__*/ (() => {
    class PolarLineSeries extends PolarLineSeriesBase {
        constructor() {
            super();
            this.ab = PolarLineSeries.$;
        }
        bk() {
            return new PolarLineSeries();
        }
        get_fl() {
            return true;
        }
        ct() {
            return new PolarLineSeriesView(this);
        }
        q7(a) {
            super.q7(a);
            this.ac4 = a;
        }
        ac2(a) {
            let b = a;
            b.dn();
        }
        ac3(a, b) {
            let c = b;
            c.dp(a.n, this.ie);
            this.zf.az(this, this.z7(), runOn(this, this.yx));
            let d = false;
            let e = this.zf.b;
            if (e != null) {
                d = true;
            }
            if (d) {
                this.abm(-1, this.zt.count, b.t);
            }
            this.zf.ad(b.dr, true, false, true, false);
        }
        acu() {
            return this.ac5;
        }
        rg(a, b, c, d) {
            super.rg(a, b, c, d);
            switch (b) {
                case PolarLineSeries.$$p[0]:
                    this.ry(false);
                    this.qr();
                    break;
            }
        }
    }
    PolarLineSeries.$t = markType(PolarLineSeries, 'PolarLineSeries', PolarLineSeriesBase.$);
    PolarLineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, PolarLineSeries, 'raisePropertyChanged', ['UnknownValuePlotting:ac5:ac7', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
    return PolarLineSeries;
})();
/**
 * @hidden
 */
export let PolarLineSeriesView = /*@__PURE__*/ (() => {
    class PolarLineSeriesView extends PolarLineSeriesBaseView {
        constructor(a) {
            super(a);
            this.dm = null;
            this.dr = new Path();
            this.dq = new Path();
            this.dm = a;
        }
        a4() {
            super.a4();
            if (!this.t) {
                this.ch.xk = Defaults.e;
            }
        }
        dn() {
            this.dr.an = null;
            this.dq.an = null;
            this.a2();
        }
        dp(a, b) {
            this.dm.acr.d(this.dr, a, b);
            this.a2();
        }
        bp() {
            super.bp();
        }
        bq() {
            super.bq();
            let a = this.b3();
            this.dq.an = this.dr.an;
            this.dq._stroke = a;
            this.dq.ad = this.f.ig + 3;
        }
        bj(a, b) {
            super.bj(a, b);
            if (a.d) {
                if (b) {
                    a.t(this.dq);
                }
                else {
                    a.t(this.dr);
                }
            }
        }
        ax(a) {
            super.ax(a);
            this.f.bc.exportPathData(a, this.dr, "polarShape", ["Main"]);
        }
    }
    PolarLineSeriesView.$t = markType(PolarLineSeriesView, 'PolarLineSeriesView', PolarLineSeriesBaseView.$);
    return PolarLineSeriesView;
})();
